
#ifndef _KXEN_INFO_H
#define _KXEN_INFO_H

#ifndef asmlinkage
#define asmlinkage
#endif

#ifdef __GNUC__
#define __WINPACKED__ __attribute__ ((aligned (8)))
#ifndef __cdecl
#define __cdecl
#endif
#else
#define __WINPACKED__
#endif

struct vm_info;

struct /* __WINPACKED__ */ kxen_info {
    int (__cdecl *ki_printf)(const char *fmt, ...);
    uint32_t ki_max_page;
    uint32_t ki_xenheap_page_count;
    uint32_t *ki_xenheap_pages;
    unsigned char *ki_xenheap_va;
    void *ki_frametable;
    void *ki_vmaptable;
    void (__cdecl *ki_kick_cpu)(unsigned int, unsigned int);
    void (__cdecl *ki_timer_interrupt)(void);
    uint64_t ki_cpu_active_mask __WINPACKED__;
    void (__cdecl *ki_signal_idle_thread)(unsigned int);
    uint32_t ki_running;
    void (__cdecl *ki_set_host_preemption)(unsigned int);
    void (__cdecl *ki_set_timer)(unsigned int, uint64_t);
    uint32_t (__cdecl *ki_get_unixtime)(void);
    uint64_t (__cdecl *ki_get_hostime)(void);
    uint32_t ki_hostime_tick_frequency;
    void (__cdecl *ki_halt_vm)(struct vm_info *);
    void (__cdecl *ki_wake_vm)(struct vm_info *);
    void (__cdecl *ki_on_each_cpu)(void (*)(void *), void *);
    void *(__cdecl *ki_map_pages)(unsigned int, void *);
    int (__cdecl *ki_unmap_pages)(unsigned int, void *);
};

struct vm_info {
    uint32_t vi_nrpages;
    uint32_t *vi_p2m;
    void *domain;
};

struct kxen_vmap {
    void *vaddr;
};

/* 13 bits = 8192 pages = 32MB (< max mdl size) */
#define KXEN_VMAPPING_SHIFT 13

#define KXEN_PAGE_SHIFT 12
#define KXEN_PAGE_SIZE (1UL << KXEN_PAGE_SHIFT)
#define KXEN_PAGE_MASK (~(KXEN_PAGE_SIZE-1))

#endif
